/******************************************************************************/
/*									      */
/* [PS XAvOC]							      */
/*									      */
/*	FILE NAME	: Plugin.c   					      */
/*	FUNCTION	: WXAANZX (CD-ROMp)			      */
/*									      */
/*	FUNCTIONS		| an outline				      */
/*    --------------------------+-------------------------------------------- */
/*	PsrQueryPlugin()	| vOC̎擾			      */
/*	PsrIsSupportCDBegin()	| CDT|[g Jn		      */
/*	PsrIsSupportCDEnd()	| CDT|[g I		      */
/*	PsrIsSupportCDSector()	| CDT|[g ZN^ʒm		      */
/*	PsrIsSupportCDResult()	| CDT|[g ʎ擾		      */
/*	PsrGetStrDataInfo()	| Xg[f[^̎擾		      */
/*	PsrOpenCD()		| CDXg[̃I[v		      */
/*	PsrClose()		| Xg[f[^̃N[Y		      */
/*	PsrRead()		| Xg[f[^̓ǂݎ		      */
/*	PsrSeek()		| ǂݎʒu̐ݒ			      */
/*									      */
/*	HISTORY		| Comment				| Name	      */
/*    ------------------+---------------------------------------+------------ */
/*	2000.07.16	| VK쐬				| ӂ      */
/*	2000.07.19	| STR̍ŌXAEႤ	1.01	| ӂ      */
/*	2000.07.20	| STȐI[		1.02	| ӂ      */
/*	2000.07.21	| ZN^sǂC		1.03	| ӂ      */
/*	2000.08.08	| STRXAEႤ2	1.04	| ӂ      */
/*	2000.08.10	| `lԍC	1.05	| ӂ      */
/*	2000.10.28	| vOCdlύX		1.10	| ӂ      */
/*	2000.11.14	| F΍			1.11	| ӂ      */
/*									      */
/*			(C) Copyright ӂ 2000. All rights reserved.       */
/******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <Windows.h>

#include "CdAccess.h"
#include "PSRP.h"

static LONG	alZERO[] = {0, 0, 0, 0, 0, 0, 0, 0};


typedef struct {	// Tuwb_[ ----------------------------------------
	USHORT		usChaNo;		// `lԍ
	BYTE		bfType;			// ^Cv
	BYTE		bfFlags;		// tO
} _TSUBHEADER, *_PTSUBHEADER;


typedef struct {	// ZN^[\ ----------------------------------------
	BYTE		abSync[12];		// CD-ROM XA 
	BYTE		abHeader[4];		// CD-ROM XA wb_[
	_TSUBHEADER	asubH[2];		// CD-ROM XA Tuwb_[ 1.05
	BYTE		abAudio[0x900];		// XA AUDIO
	BYTE		abEdc[4];		// CD-ROM XA EDC
} _TSECTOR, *_PTSECTOR;


typedef struct {	// Xg[ --------------------------------------
	DWORD		dwBegin;	// f[^JnZN^ԍ
	DWORD		nLength;	// f[^ZN^
	USHORT		usChannels;	// `l			1.05
	USHORT		usChaNo;	// `lԍ		1.05
	BYTE		bFlags;		// tO
	BYTE		bEnded;		// tO
	DWORD		nLast;		// ŏIZN^			1.11
	DWORD		nLastGood;	// ŏILZN^		1.11
} _TSTREAM, *_PTSTREAM;


typedef struct {	// Xg[Tnh̓e ------------------------
	INT		iBuffer;	// Xg[obt@
	INT		iNum;		// Xg[
	INT		iNumChannels;	// XA`l
	_PTSTREAM	pstr;		// Xg[Q
} _TFIND, *_PTFIND;


typedef struct {	// Xg[nh̓e ----------------------------
	HANDLE		hCdrom;		// CD-ROMnh
	DWORD		nBegin;		// Xg[JnZN^
	DWORD		nAllSector;	// ZN^
	DWORD		nSamplingRate;	// TvO[g
	WORD		wChannels;	// `l
	WORD		wStep;		// ZN^Ԋu
	_TSUBHEADER	subH;		// Tuwb_
	_PTSECTOR	apSector[2];	// ޔZN^
} _THANDLE, *_PTHANDLE;

/******************************************************************************/
/*									      */
/*	PsrQueryPlugin() : vOC̎擾				      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrQueryPlugin(
	LPPSRPLUGIN	lpPlugin)	// vOC擾obt@AhX
{
	strcpy(lpPlugin->aName,      "XA CD-ROM");
	strcpy(lpPlugin->aCopyright, "Copyright (c) Fyiro 2000.");
	lpPlugin->usVersion	     = 111;
	lpPlugin->usIsSupportVersion = 0;
	lpPlugin->usSystemVersion    = PSR_SYSTEMVERSION;
	strcpy(lpPlugin->aSiteName, "Fyiro's Garage");		// 1.10
	strcpy(lpPlugin->aSiteUrl, "http://homepage2.nifty.com/~mkb/");	// 1.10
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportCDBegin() : CDT|[g Jn			      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrIsSupportCDBegin(
	INT		iNumToc,	// TOC̐
	LPTOCENTRY	lptoc)		// TOC
{
	_PTFIND		pfind;
	INT		i;


	for(i=0; i<iNumToc; i++) {
		if(lptoc[i].bAdr & 0x04)	break;
	}
	if(i == iNumToc)	return NULL;

	if(!(pfind = malloc(sizeof(_TFIND))))	return NULL;

			// nh̍쐬Əݒ ----------------------------
	pfind->iBuffer	= 64;
	pfind->iNum	= 0;
	pfind->iNumChannels = 0;
	pfind->pstr	= malloc(sizeof(_TSTREAM) * pfind->iBuffer);
	if(!pfind->pstr) {
		free(pfind);
		return NULL;
	}
	return pfind;
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportCDEnd() : CDT|[g I			      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrIsSupportCDEnd(
	HANDLE		hIsCD)		// CDT|[gnh
{
	_PTFIND		pfind;


	if(!(pfind = hIsCD))	return;
	free(pfind->pstr);
	free(pfind);
}

/******************************************************************************/
/*									      */
/*	PsrIsSupportCDSector() : CDT|[g ZN^ʒm		      */
/*									      */
/******************************************************************************/

typedef struct {
	ULONG		aulCode[4];
	BYTE		abData[112];
} _ADPCM, *_PADPCM;

static BOOL	_psrIsGoodAudio(_PADPCM padpcm);

CEXPORT	BOOL	PsrIsSupportCDSector(
	HANDLE		hIsCD,		// CDT|[gnh
	TOCENTRY	toc,		// TOC
	DWORD		nSector,	// ZN^ԍ
	PVOID		pvSector)	// ZN^
{
	_PTFIND		pfind;
	_PTSECTOR	psector;
	_PTSTREAM	pstr;
	INT		i;
	USHORT		usNum;


	if(!(pfind = hIsCD))	return FALSE;
	if(!(toc.bAdr & 0x04))	return FALSE;		// CD-DA
	if(!(psector = pvSector)) {
		for(i=pfind->iNum-1; i>=0; i--) {
			if(!pfind->pstr[i].bEnded) {
				pfind->pstr[i] = pfind->pstr[pfind->iNum-1];
				pfind->iNum --;
			}
		}
		pfind->iNumChannels = 0;
		return FALSE;
	}

			// XÃZN^ł͂Ȃ ----------------------------------
	if(memcmp(psector->abAudio, alZERO, sizeof(alZERO)) == 0 ||
	   (psector->asubH[0].bfType == 0 && psector->asubH[0].bfFlags == 0)) {
		return TRUE;	// _~[
	}
	if((psector->asubH[0].bfType & 0x7f) != 0x64) {		// 1.11 ------->
		pstr = pfind->pstr;
		for(i=0; i<pfind->iNum; i++) {
			if(!pstr[i].bEnded && pstr[i].nLength != 1) {
				usNum = (USHORT)(nSector - pstr[i].nLast);
				if(usNum >= pstr[i].usChannels) {
					pstr[i].bEnded = 1;
					if(!pstr[i].nLastGood) {
						pstr[i] = pstr[pfind->iNum-1];
						pfind->iNum --;
						i --;
					}
					pfind->iNumChannels --;
				}
			}
		}
		return TRUE;
	}							// <------- 1.11

			// Xg[̒T --------------------------------
	for(pstr=NULL, i=0; i<pfind->iNum; i++) {
		if(!pfind->pstr[i].bEnded &&
		    pfind->pstr[i].usChaNo == psector->asubH[0].usChaNo) {
			pstr = &pfind->pstr[i];
			break;
		}
	}

	if(!pstr) {	// Xg[ǉ --------------------------------------
		if(pfind->iBuffer == pfind->iNum) {
			pfind->iBuffer += 16;
			pstr = realloc(pfind->pstr,
					sizeof(_TSTREAM) * pfind->iBuffer);
			if(!pstr) {
				pfind->iBuffer -= 16;
				return TRUE;	// Ƃ肠I
			}
			pfind->pstr = pstr;
		}

		pstr = &pfind->pstr[pfind->iNum];
		pstr->dwBegin	= nSector;
		pstr->nLength	= 0;
		pstr->usChannels= 1;					// 1.03
		pstr->usChaNo	= psector->asubH[0].usChaNo;
		pstr->bFlags	= psector->asubH[0].bfFlags;
		pstr->bEnded	= 0;
		pstr->nLast	= 0;					// 1.11
		pstr->nLastGood	= 0;					// 1.11
		pfind->iNum ++;
		pfind->iNumChannels ++;
	}
	if(pstr->nLength == 1) {
		pstr->usChannels = (USHORT)(nSector - pstr->dwBegin);
	}
	pstr->nLast	= nSector;					// 1.11

			// f[^LȃZN^ł邩 ----------- 1.11
	if(_psrIsGoodAudio((_PADPCM)psector->abAudio)) {
		pstr->nLastGood	= nSector;
	}

	pstr->nLength ++;

			// XAXg[̏IR[h ----------------------------
	if(psector->asubH[0].bfType & 0x80) {
		pstr->bEnded = 1;
		if(!pstr->nLastGood) {
			*pstr = pfind->pstr[pfind->iNum-1];
			pfind->iNum --;
		}
		pfind->iNumChannels --;
		return TRUE;
	}

	return TRUE;
}


//****--------------------------------------------------------------------------
//****	_psrIsGoodAudio() : f[^L
//****--------------------------------------------------------------------------

static BOOL	_psrIsGoodAudio(_PADPCM padpcm) {
	INT		i, j;

	for(i=0; i<18; i++) {
		if((padpcm->aulCode[0] && padpcm->aulCode[0] != 0x0c0c0c0c) ||
		   (padpcm->aulCode[1] && padpcm->aulCode[1] != 0x0c0c0c0c) ||
		   (padpcm->aulCode[2] && padpcm->aulCode[2] != 0x0c0c0c0c) ||
		   (padpcm->aulCode[3] && padpcm->aulCode[3] != 0x0c0c0c0c)) {
			return TRUE;
		}
		for(j=0; j<112; j++) {
			if(padpcm->abData[j])	return TRUE;
		}
		padpcm ++;
	}

	return FALSE;
}

/******************************************************************************/
/*									      */
/*	PsrIsSupportCDResult() : CDT|[g ʎ擾		      */
/*									      */
/******************************************************************************/

CEXPORT	INT	PsrIsSupportCDResult(
	HANDLE		hIsCD,		// CDT|[gnh
	INT		iIndex,		// Xg[CfbNX
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTFIND		pfind;
	_PTSTREAM	pstr;


	if(!(pfind = hIsCD))		return 0;
	if(pfind->iNum <= iIndex)	return -1;

	if(lpStreamInfo) {
		pstr = &pfind->pstr[iIndex];
		memset(lpStreamInfo, 0, sizeof(PSRSTREAMINFO));
		lpStreamInfo->wTypeFlags	= PSR_STRTYPE_AUDIO;
		lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
		lpStreamInfo->wBitsPerSample	= 16;
		lpStreamInfo->nBeginSector	= pstr->dwBegin;
		lpStreamInfo->nNumSector	=
			(DWORD)pstr->usChannels * (pstr->nLength - 1) + 1;// 1.03
		lpStreamInfo->wChannels		= (pstr->bFlags & 0x01) ? 2 : 1;
		lpStreamInfo->nSamplesPerSec	= (pstr->bFlags & 0x04) ? 18900:37800;
		lpStreamInfo->nPlayTime = (40320 * pstr->nLength) /
				(lpStreamInfo->wChannels *
					(lpStreamInfo->nSamplesPerSec / 100));
		lpStreamInfo->nDataSize = pstr->nLength * 0x900;	//1.30
	}
	return pfind->iNum;
}

/******************************************************************************/
/*									      */
/*	PsrGetStrDataInfo() : Xg[f[^̎擾		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrGetStrDataInfo(
	INT		iDriveNo,	// hCuԍ
	DWORD		dwBegin,	// JnZN^ԍ
	DWORD		dwNumSector,	// ZN^
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	HANDLE		hCdrom;
	_PTSECTOR	psector;
	_TSUBHEADER	subH;
	DWORD		nStep;


			// CD-ROM̃I[v ------------------------------------
	hCdrom = CdReadOpen(iDriveNo, NULL, dwBegin, min(256, dwNumSector), -1);
	if(!hCdrom)	return FALSE;

			// ŏ̃ZN^ǂݍ ------------------------------
	if(!(psector = CdReadSector(hCdrom, NULL))) {
		CdReadClose(hCdrom);
		return FALSE;
	}
	subH = psector->asubH[0];
	subH.bfType &= 0x7f;
	CdUnlockReadBuffer(hCdrom, psector);

	nStep = 1;	// ZN^Ԋu߂ ----------------------------- 1.03
	if(dwNumSector <= 1) {
		while(1) {
			if(!(psector = CdReadSector(hCdrom, NULL))) {
				CdReadClose(hCdrom);
				return FALSE;
			}
			if(subH.usChaNo == psector->asubH[0].usChaNo &&
			   subH.bfType == (psector->asubH[0].bfType & 0x7f) &&
			   subH.bfFlags == psector->asubH[0].bfFlags) {
				break;
			}
			nStep ++;
			CdUnlockReadBuffer(hCdrom, psector);
		}
	}
	CdReadClose(hCdrom);

			// Xg[ݒ肷 ----------------------------
	memset(lpStreamInfo, 0, sizeof(PSRSTREAMINFO));
	lpStreamInfo->wTypeFlags	= PSR_STRTYPE_AUDIO;
	lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
	lpStreamInfo->wBitsPerSample	= 16;
	lpStreamInfo->nBeginSector	= dwBegin;
	lpStreamInfo->nNumSector	= dwNumSector;
	lpStreamInfo->wChannels		= (subH.bfFlags & 0x01) ? 2 : 1;
	lpStreamInfo->nSamplesPerSec	= (subH.bfFlags & 0x04) ? 18900 : 37800;
	dwNumSector = (dwNumSector + (nStep - 1)) / nStep;
	lpStreamInfo->nPlayTime = (40320 * dwNumSector) /
				((DWORD)lpStreamInfo->wChannels *
					(lpStreamInfo->nSamplesPerSec / 100));
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrOpenCD() : CDXg[̃I[v				      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrOpenCD(
	INT		iDriveNo,	// hCuԍ
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTHANDLE	phandle;
	HANDLE		hCdrom;
	_PTSECTOR	psector;


			// CD-ROM̃I[v ------------------------------------
	hCdrom = CdReadOpen(iDriveNo, NULL,
				lpStreamInfo->nBeginSector,
				lpStreamInfo->nNumSector, -1);
	if(!hCdrom)	return NULL;

			// nh쐬 --------------------------------------
	if(!(phandle = malloc(sizeof(_THANDLE)))) {
		CdReadClose(hCdrom);
		return NULL;
	}
	phandle->hCdrom		= hCdrom;
	phandle->nBegin		= lpStreamInfo->nBeginSector;
	phandle->nAllSector	= lpStreamInfo->nNumSector;
	phandle->nSamplingRate	= lpStreamInfo->nSamplesPerSec;
	phandle->wChannels	= lpStreamInfo->wChannels;
	phandle->wStep		= 1;					// 1.03
	phandle->apSector[0]	= NULL;					// 1.03
	phandle->apSector[1]	= NULL;					// 1.03

			// ZN^̊Ԋu߂ --------------------------------
	if(!(phandle->apSector[0] = CdReadSector(hCdrom, NULL))) {
		free(phandle);
		CdReadClose(hCdrom);
		return NULL;
	}
	phandle->subH = phandle->apSector[0]->asubH[0];
	phandle->subH.bfType &= 0x7f;
	while(lpStreamInfo->nNumSector > 1) {				// 1.03
		if(!(psector = CdReadSector(hCdrom, NULL))) {
			free(phandle);
			CdReadClose(hCdrom);
			return NULL;
		}
		if(phandle->subH.usChaNo == psector->asubH[0].usChaNo &&
		   phandle->subH.bfType == (psector->asubH[0].bfType & 0x7f) &&
		   phandle->subH.bfFlags == psector->asubH[0].bfFlags) {
			phandle->apSector[1] = psector;
			break;
		}
		phandle->wStep ++;					// 1.03
	}

	return phandle;
}

/******************************************************************************/
/*									      */
/*	PsrClose() : Xg[f[^̃N[Y				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrClose(
	HANDLE		hStream)	// Xg[nh
{
	_PTHANDLE	phandle;


	phandle = hStream;
	if(phandle->hCdrom)	CdReadClose(phandle->hCdrom);
	free(phandle);
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrRead() : Xg[f[^̓ǂݎ				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrRead(
	HANDLE		hStream,	// Xg[nh
	LPPSRREADBUFF	lpBuffer)	// ǂݎobt@
{
	_PTHANDLE	phandle;
	_PTSECTOR	psector;


	phandle = hStream;
	memset(lpBuffer, 0, sizeof(PSRREADBUFF) - PSR_FRAMEBUFFER);

	if(phandle->apSector[0]) {
		psector = phandle->apSector[0];
		phandle->apSector[0] = NULL;
	} else if(phandle->apSector[1]) {
		psector = phandle->apSector[1];
		phandle->apSector[1] = NULL;
	} else {
		psector = NULL;
	}
	if(psector) {
		lpBuffer->nLength = 0x900;
		memcpy(lpBuffer->abData, psector->abAudio, 0x900);
		CdUnlockReadBuffer(phandle->hCdrom, psector);
		return TRUE;
	}

	while(1) {
		psector = CdReadSector(phandle->hCdrom, NULL);
		if(!psector)	return FALSE;

		if(phandle->subH.usChaNo == psector->asubH[0].usChaNo &&
		   phandle->subH.bfType == (psector->asubH[0].bfType & 0x7f) &&
		   phandle->subH.bfFlags == psector->asubH[0].bfFlags) {
			lpBuffer->nLength	= 0x900;
			memcpy(lpBuffer->abData, psector->abAudio, 0x900);
		}
		CdUnlockReadBuffer(phandle->hCdrom, psector);
		if(lpBuffer->nLength)	break;
	}
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrSeek() : ǂݎʒu̐ݒ					      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrSeek(
	HANDLE		hStream,	// Xg[nh
	DWORD		dwPosition)	// ǂݎʒu		1/1000bP
{
	_PTHANDLE	phandle;
	DWORD		dwSector;


	phandle = hStream;
	if(phandle->apSector[0]) {
		CdUnlockReadBuffer(phandle->hCdrom, phandle->apSector[0]);
		phandle->apSector[0] = NULL;
	}
	if(phandle->apSector[1]) {
		CdUnlockReadBuffer(phandle->hCdrom, phandle->apSector[1]);
		phandle->apSector[1] = NULL;
	}

	dwSector = (phandle->nSamplingRate / 100) * (dwPosition / 10);
	dwSector /= (4032 / (DWORD)phandle->wChannels);
	dwSector *= (DWORD)phandle->wStep;
	dwSector = min(dwSector, phandle->nAllSector);
	if(CdSetReadPointer(phandle->hCdrom, (LONG)dwSector, FILE_BEGIN) == 0xffffffff) {
		return FALSE;
	}
	return TRUE;
}
